Properties Methods Events Direct Link

    DragDrop
      DD

# Class Ext.dd.DD

Package: | Ext.dd
Defined In: | DDCore.js
Class: | DD
Subclasses: | DDProxy
Extends: | DragDrop

A DragDrop implementation where the linked element follows the mouse cursor during a drag.

## Public Properties

Property | Defined By
--- | ---
| available : boolean The availabe property is false until the linked dom element is accessible. | DragDrop
| config : object Configuration attributes passed into the constructor | DragDrop
| groups : object The group defines a logical collection of DragDrop objects that are related. Instances only get events when interact... The group defines a logical collection of DragDrop objects that are related. Instances only get events when interacting with other DragDrop object in the same group. This lets us define multiple groups using a single DragDrop subclass if we want. | DragDrop

hasOuterHandles : boolean
By default, drags can only be initiated if the mousedown occurs in the region the linked element is. This is done in...
By default, drags can only be initiated if the mousedown occurs in the region the linked element is. This is done in part to work around a bug in some browsers that mis-report the mousedown if the previous mouseup happened outside of the window. This property is set to true if outer handles are defined.

DragDrop

| id : String The id of the element associated with this object. This is what we refer to as the "linked element" because the size... The id of the element associated with this object. This is what we refer to as the "linked element" because the size and position of this element is used to determine when the drag and drop objects have interacted. | DragDrop
| invalidHandleClasses : string[] An indexted array of css class names for elements that will be ignored if clicked. | DragDrop
| invalidHandleIds : string: An associative array of ids for elements that will be ignored if clicked | DragDrop
| invalidHandleTypes : string: An associative array of HTML tags that will be ignored if clicked. | DragDrop
| isTarget : boolean By default, all insances can be a drop target. This can be disabled by setting isTarget to false. | DragDrop
| maintainOffset : boolean Maintain offsets when we resetconstraints. Set to true when you want the position of the element relative to its par... Maintain offsets when we resetconstraints. Set to true when you want the position of the element relative to its parent to stay the same when the page changes | DragDrop
| padding : int[] The padding configured for this drag and drop object for calculating the drop zone intersection with this object. | DragDrop
| primaryButtonOnly : boolean By default the drag and drop instance will only respond to the primary button click (left button for a right-handed m... By default the drag and drop instance will only respond to the primary button click (left button for a right-handed mouse). Set to true to allow drag and drop to start with any mouse click that is propogated by the browser | DragDrop
| scroll : boolean When set to true, the utility automatically tries to scroll the browser window wehn a drag and drop element is dragge... When set to true, the utility automatically tries to scroll the browser window wehn a drag and drop element is dragged near the viewport boundary. Defaults to true. | DD
| xTicks : int[] Array of pixel locations the element will snap to if we specified a horizontal graduation/interval. This array is ge... Array of pixel locations the element will snap to if we specified a horizontal graduation/interval. This array is generated automatically when you define a tick interval. | DragDrop
| yTicks : int[] Array of pixel locations the element will snap to if we specified a vertical graduation/interval. This array is gene... Array of pixel locations the element will snap to if we specified a vertical graduation/interval. This array is generated automatically when you define a tick interval. | DragDrop

## Public Methods

Method | Defined By
--- | ---

DD( `String id`, `String sGroup`, `object config` )
Parameters:

- `id` : String
  the id of the linked element
- `sGroup` : String
  the group of related DragDrop items
- `config` : object
  an object containing configurable attributes Valid properties for DD: scroll

Returns:

- ``

DD

addInvalidHandleClass( `string cssClass` ) : void
Lets you specify a css class of elements that will not initiate a drag
Lets you specify a css class of elements that will not initiate a drag
Parameters:

- `cssClass` : string
  the class of the elements you wish to ignore

Returns:

- `void`

DragDrop

addInvalidHandleId( `string id` ) : void
Lets you to specify an element id for a child of a drag handle that should not initiate a drag
Lets you to specify an element id for a child of a drag handle that should not initiate a drag
Parameters:

- `id` : string
  the element id of the element you wish to ignore

Returns:

- `void`

DragDrop

addInvalidHandleType( `string tagName` ) : void
Allows you to specify a tag name that should not start a drag operation when clicked. This is designed to facilitate...
Allows you to specify a tag name that should not start a drag operation when clicked. This is designed to facilitate embedding links within a drag handle that do something other than start the drag.
Parameters:

- `tagName` : string
  the type of element to exclude

Returns:

- `void`

DragDrop

addToGroup( `sGroup {string}` ) : void
Add this instance to a group of related drag/drop objects. All instances belong to at least one group, and can belon...
Add this instance to a group of related drag/drop objects. All instances belong to at least one group, and can belong to as many groups as needed.
Parameters:

- `{string}` : sGroup
  the name of the group

Returns:

- `void`

DragDrop

alignElWithMouse( `HTMLElement el`, `int iPageX`, `int iPageY` ) : void
Sets the element to the location of the mousedown or click event, maintaining the cursor location relative to the loc...
Sets the element to the location of the mousedown or click event, maintaining the cursor location relative to the location on the element that was clicked. Override this if you want to place the element in a location other than where the cursor is.
Parameters:

- `el` : HTMLElement
  the element to move
- `iPageX` : int
  the X coordinate of the mousedown or drag event
- `iPageY` : int
  the Y coordinate of the mousedown or drag event

Returns:

- `void`

DD

applyConfig() : void
Applies the configuration parameters that were passed into the constructor. This is supposed to happen at each level ...
Applies the configuration parameters that were passed into the constructor. This is supposed to happen at each level through the inheritance chain. So a DDProxy implentation will execute apply config on DDProxy, DD, and DragDrop in order to get all of the parameters that are available in each object.
Parameters:

- None.

Returns:

- `void`

DragDrop

autoOffset( `int iPageX`, `int iPageY` ) : void
Sets the pointer offset to the distance between the linked element's top left corner and the location the element was...
Sets the pointer offset to the distance between the linked element's top left corner and the location the element was clicked
Parameters:

- `iPageX` : int
  the X coordinate of the click
- `iPageY` : int
  the Y coordinate of the click

Returns:

- `void`

DD

cachePosition( `iPageX the`, `iPageY the` ) : void
Saves the most recent position so that we can reset the constraints and tick marks on-demand. We need to know this s...
Saves the most recent position so that we can reset the constraints and tick marks on-demand. We need to know this so that we can calculate the number of pixels the element is offset from its original position.
Parameters:

- `the` : iPageX
  current x position (optional, this just makes it so we don't have to look it up again)
- `the` : iPageY
  current y position (optional, this just makes it so we don't have to look it up again)

Returns:

- `void`

DD

clearConstraints() : void
Clears any constraints applied to this instance. Also clears ticks since they can't exist independent of a constrain...
Clears any constraints applied to this instance. Also clears ticks since they can't exist independent of a constraint at this time.
Parameters:

- None.

Returns:

- `void`

DragDrop

clearTicks() : void
Clears any tick interval defined for this instance
Clears any tick interval defined for this instance
Parameters:

- None.

Returns:

- `void`

DragDrop

endDrag( `Event e` ) : void
Fired when we are done dragging the object
Fired when we are done dragging the object
Parameters:

- `e` : Event
  the mouseup event

Returns:

- `void`

DragDrop

getDragEl() : HTMLElement
Returns a reference to the actual element to drag. By default this is the same as the html element, but it can be as...
Returns a reference to the actual element to drag. By default this is the same as the html element, but it can be assigned to another element. An example of this can be found in Ext.dd.DDProxy
Parameters:

- None.

Returns:

- `HTMLElement`
  the html element

DragDrop

getEl() : HTMLElement
Returns a reference to the linked element
Returns a reference to the linked element
Parameters:

- None.

Returns:

- `HTMLElement`
  the html element

DragDrop

init( `id the`, `String sGroup`, `object config` ) : void
Sets up the DragDrop object. Must be called in the constructor of any Ext.dd.DragDrop subclass
Sets up the DragDrop object. Must be called in the constructor of any Ext.dd.DragDrop subclass
Parameters:

- `the` : id
  id of the linked element
- `sGroup` : String
  the group of related items
- `config` : object
  configuration attributes

Returns:

- `void`

DragDrop

initTarget( `id the`, `String sGroup`, `object config` ) : void
Initializes Targeting functionality only... the object does not get a mousedown handler.
Initializes Targeting functionality only... the object does not get a mousedown handler.
Parameters:

- `the` : id
  id of the linked element
- `sGroup` : String
  the group of related items
- `config` : object
  configuration attributes

Returns:

- `void`

DragDrop

isLocked() : boolean
Returns true if this instance is locked, or the drag drop mgr is locked (meaning that all drag/drop is disabled on th...
Returns true if this instance is locked, or the drag drop mgr is locked (meaning that all drag/drop is disabled on the page.)
Parameters:

- None.

Returns:

- `boolean`
  true if this obj or all drag/drop is locked, else false

DragDrop

isValidHandleChild( `HTMLElement node` ) : boolean
Checks the tag exclusion list to see if this click should be ignored
Checks the tag exclusion list to see if this click should be ignored
Parameters:

- `node` : HTMLElement
  the HTMLElement to evaluate

Returns:

- `boolean`
  true if this is a valid tag type, false if not

DragDrop

lock() : void
Lock this instance
Lock this instance
Parameters:

- None.

Returns:

- `void`

DragDrop

onAvailable() : void
Override the onAvailable method to do what is needed after the initial position was determined.
Override the onAvailable method to do what is needed after the initial position was determined.
Parameters:

- None.

Returns:

- `void`

DragDrop

onDrag( `Event e` ) : void
Abstract method called during the onMouseMove event while dragging an object.
Abstract method called during the onMouseMove event while dragging an object.
Parameters:

- `e` : Event
  the mousemove event

Returns:

- `void`

DragDrop

onDragDrop( `Event e`, `String|DragDrop[] id` ) : void
Abstract method called when this item is dropped on another DragDrop obj
Abstract method called when this item is dropped on another DragDrop obj
Parameters:

- `e` : Event
  the mouseup event
- `id` : String|DragDrop[]
  In POINT mode, the element id this was dropped on. In INTERSECT mode, an array of dd items this was dropped on.

Returns:

- `void`

DragDrop

onDragEnter( `Event e`, `String|DragDrop[] id` ) : void
Abstract method called when this element fist begins hovering over another DragDrop obj
Abstract method called when this element fist begins hovering over another DragDrop obj
Parameters:

- `e` : Event
  the mousemove event
- `id` : String|DragDrop[]
  In POINT mode, the element id this is hovering over. In INTERSECT mode, an array of one or more dragdrop items being hovered over.

Returns:

- `void`

DragDrop

onDragOut( `Event e`, `String|DragDrop[] id` ) : void
Abstract method called when we are no longer hovering over an element
Abstract method called when we are no longer hovering over an element
Parameters:

- `e` : Event
  the mousemove event
- `id` : String|DragDrop[]
  In POINT mode, the element id this was hovering over. In INTERSECT mode, an array of dd items that the mouse is no longer over.

Returns:

- `void`

DragDrop

onDragOver( `Event e`, `String|DragDrop[] id` ) : void
Abstract method called when this element is hovering over another DragDrop obj
Abstract method called when this element is hovering over another DragDrop obj
Parameters:

- `e` : Event
  the mousemove event
- `id` : String|DragDrop[]
  In POINT mode, the element id this is hovering over. In INTERSECT mode, an array of dd items being hovered over.

Returns:

- `void`

DragDrop

onInvalidDrop( `Event e` ) : void
Abstract method called when this item is dropped on an area with no drop target
Abstract method called when this item is dropped on an area with no drop target
Parameters:

- `e` : Event
  the mouseup event

Returns:

- `void`

DragDrop

onMouseDown( `Event e` ) : void
Event handler that fires when a drag/drop obj gets a mousedown
Event handler that fires when a drag/drop obj gets a mousedown
Parameters:

- `e` : Event
  the mousedown event

Returns:

- `void`

DragDrop

onMouseUp( `Event e` ) : void
Event handler that fires when a drag/drop obj gets a mouseup
Event handler that fires when a drag/drop obj gets a mouseup
Parameters:

- `e` : Event
  the mouseup event

Returns:

- `void`

DragDrop

removeFromGroup( `string sGroup` ) : void
Remove's this instance from the supplied interaction group
Remove's this instance from the supplied interaction group
Parameters:

- `sGroup` : string
  The group to drop

Returns:

- `void`

DragDrop

removeInvalidHandleClass( `string cssClass` ) : void
Unsets an invalid css class
Unsets an invalid css class
Parameters:

- `cssClass` : string
  the class of the element(s) you wish to re-enable

Returns:

- `void`

DragDrop

removeInvalidHandleId( `string id` ) : void
Unsets an invalid handle id
Unsets an invalid handle id
Parameters:

- `id` : string
  the id of the element to re-enable

Returns:

- `void`

DragDrop

removeInvalidHandleType( `string tagName` ) : void
Unsets an excluded tag name set by addInvalidHandleType
Unsets an excluded tag name set by addInvalidHandleType
Parameters:

- `tagName` : string
  the type of element to unexclude

Returns:

- `void`

DragDrop

resetConstraints( `boolean maintainOffset` ) : void
resetConstraints must be called if you manually reposition a dd element.
resetConstraints must be called if you manually reposition a dd element.
Parameters:

- `maintainOffset` : boolean

Returns:

- `void`

DragDrop

setDelta( `int iDeltaX`, `int iDeltaY` ) : void
Sets the pointer offset. You can call this directly to force the offset to be in a particular location (e.g., pass i...
Sets the pointer offset. You can call this directly to force the offset to be in a particular location (e.g., pass in 0,0 to set it to the center of the object)
Parameters:

- `iDeltaX` : int
  the distance from the left
- `iDeltaY` : int
  the distance from the top

Returns:

- `void`

DD

setDragElId( `id {string}` ) : void
Allows you to specify that an element other than the linked element will be moved with the cursor during a drag
Allows you to specify that an element other than the linked element will be moved with the cursor during a drag
Parameters:

- `{string}` : id
  the id of the element that will be used to initiate the drag

Returns:

- `void`

DragDrop

setDragElPos( `int iPageX`, `int iPageY` ) : void
Sets the drag element to the location of the mousedown or click event, maintaining the cursor location relative to th...
Sets the drag element to the location of the mousedown or click event, maintaining the cursor location relative to the location on the element that was clicked. Override this if you want to place the element in a location other than where the cursor is.
Parameters:

- `iPageX` : int
  the X coordinate of the mousedown or drag event
- `iPageY` : int
  the Y coordinate of the mousedown or drag event

Returns:

- `void`

DD

setHandleElId( `id {string}` ) : void
Allows you to specify a child of the linked element that should be used to initiate the drag operation. An example o...
Allows you to specify a child of the linked element that should be used to initiate the drag operation. An example of this would be if you have a content div with text and links. Clicking anywhere in the content area would normally start the drag operation. Use this method to specify that an element inside of the content div is the element that starts the drag operation.
Parameters:

- `{string}` : id
  the id of the element that will be used to initiate the drag.

Returns:

- `void`

DragDrop

setInitialPosition( `int diffX`, `int diffY` ) : void
Stores the initial placement of the linked element.
Stores the initial placement of the linked element.
Parameters:

- `diffX` : int
  the X offset, default 0
- `diffY` : int
  the Y offset, default 0

Returns:

- `void`

DragDrop

setOuterHandleElId( `id the` ) : void
Allows you to set an element outside of the linked element as a drag handle
Allows you to set an element outside of the linked element as a drag handle
Parameters:

- `the` : id
  id of the element that will be used to initiate the drag

Returns:

- `void`

DragDrop

setPadding( `int iTop`, `int iRight`, `int iBot`, `int iLeft` ) : void
Configures the padding for the target zone in px. Effectively expands (or reduces) the virtual object size for targe...
Configures the padding for the target zone in px. Effectively expands (or reduces) the virtual object size for targeting calculations. Supports css-style shorthand; if only one parameter is passed, all sides will have that padding, and if only two are passed, the top and bottom will have the first param, the left and right the second.
Parameters:

- `iTop` : int
  Top pad
- `iRight` : int
  Right pad
- `iBot` : int
  Bot pad
- `iLeft` : int
  Left pad

Returns:

- `void`

DragDrop

setXConstraint( `int iLeft`, `int iRight`, `int iTickSize` ) : void
By default, the element can be dragged any place on the screen. Use this method to limit the horizontal travel of th...
By default, the element can be dragged any place on the screen. Use this method to limit the horizontal travel of the element. Pass in 0,0 for the parameters if you want to lock the drag to the y axis.
Parameters:

- `iLeft` : int
  the number of pixels the element can move to the left
- `iRight` : int
  the number of pixels the element can move to the right
- `iTickSize` : int
  optional parameter for specifying that the element should move iTickSize pixels at a time.

Returns:

- `void`

DragDrop

setYConstraint( `int iUp`, `int iDown`, `int iTickSize` ) : void
By default, the element can be dragged any place on the screen. Set this to limit the vertical travel of the element...
By default, the element can be dragged any place on the screen. Set this to limit the vertical travel of the element. Pass in 0,0 for the parameters if you want to lock the drag to the x axis.
Parameters:

- `iUp` : int
  the number of pixels the element can move up
- `iDown` : int
  the number of pixels the element can move down
- `iTickSize` : int
  optional parameter for specifying that the element should move iTickSize pixels at a time.

Returns:

- `void`

DragDrop

startDrag( `int X`, `int Y` ) : void
Abstract method called after a drag/drop object is clicked and the drag or mousedown time thresholds have beeen met.
Abstract method called after a drag/drop object is clicked and the drag or mousedown time thresholds have beeen met.
Parameters:

- `X` : int
  click location
- `Y` : int
  click location

Returns:

- `void`

DragDrop

toString() : string
toString method
toString method
Parameters:

- None.

Returns:

- `string`
  string representation of the dd obj

DragDrop

unlock() : void
Unlock this instace
Unlock this instace
Parameters:

- None.

Returns:

- `void`

DragDrop

unreg() : void
Remove all drag and drop hooks for this element
Remove all drag and drop hooks for this element
Parameters:

- None.

Returns:

- `void`

DragDrop

## Public Events

This class has no public events.